<?php

if (defined("_INC_MOTSCLEFS")) return;
define("_INC_CLONES", "1");

//
// À partir d'une liste de groupes de mots-clefs, la fonction
// retourne un array avec toutes les infos sur les groupes et
// place un array de mots-clefs du groupes dans liste_mots.
//
function prendre_tout_sur_motsclefs($motsclefs) {
	$version_spip = lire_meta('version_installee');
	$groupes = array();

	foreach ($motsclefs as $mot) {
		$query1 = "SELECT id_groupe, titre, unseul, obligatoire, articles,
						breves, rubriques, syndic, 0minirezo, 1comite, 6forum
					FROM spip_groupes_mots
					WHERE id_groupe = $mot";
		$result1 = spip_query($query1);

		if (spip_sql_errno()) 
			echo "<p><b>" . spip_sql_error() .  "</b></p><p><tt>$query1</tt></p>\n";

		while ($row1 = spip_fetch_array($result1)) {
			// Placer tous les mots-clefs du groupe dans liste_mots.
			// Ce sera plus pratique pour plus tard.
			$row1['liste_mots'] = array();

			$query2 = "SELECT id_mot, type, titre, descriptif, texte,
							id_groupe, extra, idx ";
								
			if ($version_spip > 1.8)
				$query2 .= ", url_propre ";

			$query2 .= "FROM spip_mots WHERE id_groupe = $mot";
			$result2 = spip_query($query2);

			if (spip_sql_errno()) 
				echo "<p><b>" . spip_sql_error() .  "</b></p><p><tt>$query1</tt></p>\n";

			while ($row2 = spip_fetch_array($result2))
				array_push($row1['liste_mots'], $row2);

			array_push($groupes, $row1);
		}
	}

	return $groupes;
}

function inserer_groupe_dans_site($site, $groupes) {
	$log = ""; // retour
	$clone = get_clone($site);
	$inc_connect = $clone['clone_path_dest'] . "/ecrire/inc_connect.php3";

	if (! @is_file($inc_connect)) {
		$log .= "<p>Le fichier '$inc_connect' n'existe pas ou n'est pas un fichier</p>";
		return $log;
	} 

	// un include() d'inc_connect est impossible à cause des
	// constantes définies.. N'étant pas très familier avec le 
	// PHP, je sors la scie troconneuse pour couper le fromage:
	function reconnect_db_avec_hache($conf) {
		$fd = fopen($conf, 'r');
		while (!feof ($fd)) {
			$buffer = fgets($fd, 4096);
			if (preg_match("/.*spip_connect_db\('(.*)','','(.*)','(.*)','(.*)'/", $buffer, $regs)) {
				spip_connect_db($regs[1], '', $regs[2], $regs[3], $regs[4]);
				fclose($fd);
				return true;
			}
		}

		fclose($fd);
		return false;
	}

	if (! reconnect_db_avec_hache($inc_connect)) {
		$log .= "<p>$site: mal DB non-configurée? (problème avec inc_connect)</p>";
		return $log;
	}

	foreach ($groupes as $g) {
		$conflict = 0;
		$query = "SELECT id_groupe, titre FROM spip_groupes_mots ";

		if ($detection_doublons == 'par_id')
			$query .= "WHERE id_groupe = " . $g['id_groupe'];
		else
			$query .= "WHERE titre = '" . addslashes($g['titre']) . "'";

		$result = spip_query($query);

		if (spip_sql_errno()) 
			$log .= "<p><b>" . spip_sql_error() .  "</b></p><p><tt>$query</tt></p>";

		while($row = spip_fetch_array($result)) {
			$log .= "<p>$site: Groupe id = " . $g['id_groupe'] . ", titre = " . $g['titre']
				. " : existe d&eacute;j&agrave;.</p>\n";
			$id_groupe = $g['id_groupe'];
			$conflict++;
		}

		if (! $conflict) {
			$query = "INSERT INTO spip_groupes_mots (titre, unseul,
				obligatoire, articles, breves, rubriques, syndic,
				0minirezo, 1comite, 6forum)
					VALUES ('" . addslashes($g['titre']) . "', " 
					. "'" . $g['unseul'] . "', " 
					. "'" . $g['obligatoire'] . "', " 
					. "'" . $g['articles'] . "', "
					. "'" . $g['breves'] . "', "
					. "'" . $g['rubriques'] . "', "
					. "'" . $g['syndic'] . "', "
					. "'" . $g['0minirezo'] . "', "
					. "'" . $g['1comite'] . "', "
					. "'" . $g['6forum'] . "')";
			$result = spip_query($query);

			if (spip_sql_errno())
				echo "<p><b>" . spip_sql_error() .  "</b></p><p><tt>$query</tt></p>\n";

			$id_groupe = spip_insert_id();
			spip_log($query);
		}

		if ($id_groupe) {
			foreach ($g['liste_mots'] as $h) {
				$conflict = 0;
				$query = "SELECT id_mot, titre FROM spip_mots ";

				if ($detection_doublons == 'par_id')
					$query .= "WHERE id_mot = " . $h['id_mot'];
				else
					$query .= "WHERE titre = '" . addslashes($h['titre']) . "'";

				$result = spip_query($query);

				if (spip_sql_errno()) 
					echo "<p><b>" . spip_sql_error() .  "</b></p><p><tt>$query</tt></p>\n";

				while($row = spip_fetch_array($result)) {
					echo "<p>$site: Mot id = " . $row['id_mot'] . ", titre = " . $row['titre']
						. " : existe d&eacute;j&agrave;.</p>\n";
					$conflict++;
				}

				if (! $conflict) {
					$query = "INSERT INTO spip_mots (type, titre,
							descriptif, texte, id_groupe, extra, idx";

					if ($version_spip > 1.8)
						$query .= ", idx, url_propre";

					$query .= ")
						VALUES ('" . $h['type'] . "', "
							. "'" . addslashes($h['titre']) . "', " 
							. "'" . addslashes($h['descriptif']) . "', "
							. "'" . addslashes($h['texte']) . "', "
							. $id_groupe . ", "
							. ($h['extra'] ? $h['extra'] : "NULL") . ", "
							. "'" . $h['idx'] . "'";

					if ($version_spip > 1.8)
						$query .= ", '" . $h['url_propre'] . "'";

					$query .= ")";
					$result = spip_query($query);

					if (spip_sql_errno()) 
						echo "<p><b>" . spip_sql_error() .  "</b></p><p><tt>$query</tt></p>";

					$id_mot = spip_insert_id();
				}
			}
		} else {
			$log .= "<p>Par une étrange raison, je n'ai pas de id_groupe</p>";
		}
	}

	return $log;
}

?>
